nomainwin
' Main window size
WindowWidth = 290
WindowHeight = 360
UpperLeftX=int((DisplayWidth-WindowWidth)/2)
UpperLeftY=int((DisplayHeight-WindowHeight)/2)
' add text and controls
statictext #main.DisplayBox, "Waiting", 25, 30, 135, 160
statictext #main.DataIndicator, "waiting", 20, 220, 240, 18
statictext #main.LogIndicator, " ", 20,240,240,18
statictext #main.RemoteLogIndicator, " ", 20,260,240,18
statictext #main.RemoteLogResponse, " ", 20,280,240,30
BUTTON #main.Calibrate, "Calibrate", [CalScreen], UL, 180, 30 , 90, 25
BUTTON #main.Setup, "Setup", [SetupScreen], UL, 180, 60 , 90, 25
BUTTON #main.ComData, "Com Data", [ComDataScreen], UL, 180, 90 , 90, 25
BUTTON #main.Graphs, "Open PicGraph", [OpenPicGraph], UL, 180, 120 , 90, 25
BUTTON #main.ResetWh, "Reset Wh", [ResetWatthours], UL, 180, 150 , 90, 25
Groupbox #main.g1, "Current Readings", 10,10,160,185
Groupbox #main.g1, "Process Info", 10,200,260,115

open "PicLog 2.0" for window as #main
print #main, "trapclose [quit]"
print #main, "font ms_sans_serif 8"

temp=mkdir("LogFiles") ' Make sure we have a log folder

PortOpen=0
PortOK=0
Dim ComArray$(32)
Dim BaudArray$(2)
BaudArray$(1)="4800"
BaudArray$(2)="9600"

Gosub [GetConfig]

' Get list of com ports, put into array, and check if nominated port is OK to use
PortOK=0
for Port = 1 to 32
    oncomerror [trap]
    found=0
    open "Com";str$(Port);":4800,n,8,1" for random as #com
    found=1
    [trap]
    if found=1 then
        ComPortCount=ComPortCount+1
        ComArray$(ComPortCount)=str$(Port)
        if PortNumber$=str$(Port) then PortOK=1
        close #com
    end if
    oncomerror
next Port
if PortOK=0 then
    notice "Com port error, please select another com port in the Setup screen"
    goto [SetupScreen]
else
    goto [Start]
end if


[Start]
    ' Open com port
    if PortOpen=0 then
        Com=512
        open "COM" + PortNumber$ + ":" + BaudRate$ + ",n,8,1,ds0,cs0,rs" for random as #comm
        PortOpen=1
    end if

    ' Test to see if log file for today exists.
    Dim FileInfo$(10,10)
    files DefaultDir$ + "\logfiles", replace$(date$("yyyy/mm/dd"),"/","_") + ".txt", FileInfo$()
    if val(FileInfo$(0, 0))=1 then
        ' If so, get the last log entry
        open DefaultDir$ + "\logfiles\" + replace$(date$("yyyy/mm/dd"),"/","_") + ".txt" for input as #f
            while eof(#f) = 0
                line input #f, LogFileEntry$
            wend
        close #f
        ' Got the last entry, now extract the Watthours figure from it
        If InStr(LogFileEntry$, "<Wh>") > 0 And InStr(LogFileEntry$, "</Wh>") > InStr(LogFileEntry$, "<Wh>") Then
            WattHours = val(Mid$(LogFileEntry$, InStr(LogFileEntry$, "<Wh>") + 4, InStr(LogFileEntry$, "</Wh>") - InStr(LogFileEntry$, "<Wh>") - 4))
        else
            WattHours=0
        end if
    else
        WattHours=0
    end if

    ' Start the timer. 1 second interval. [RunQue] will be called every second.
    Timer 1000, [RunQue]
Wait


[RunQue]
    ' Grab a chunk of data from the serial buffer
    SerialData$ = SerialData$ + input$(#comm, lof(#comm))
    if len(SerialData$)>1 then
        DC=0
        do until instr(SerialData$,"]")=0
            DC=DC+1
            BlockStartPos=instr(SerialData$,"[")
            if BlockStartPos>1 then
                SerialData$=mid$(SerialData$,BlockStartPos)
                BlockStartPos=1
            end if
            BlockEndPos=instr(SerialData$,"]")
            if BlockStartPos>0 and BlockEndPos>BlockStartPos then
                if ComDataFlag=1 then print #ComDataScreen.ComData, left$(SerialData$,BlockEndPos) 'Send to ComData screen if open
                gosub [ParseData] 'Extract and process data
                if CalFlag=1 then gosub [UpdateCalScreen] 'Update Cal Screen if its open
           end if
        loop
    else
         print #main.DataIndicator, "waiting"
    end if
    WattHours=WattHours+(Watts*0.0002777) ' Calculate Watthours per second.
    if ResetMax=1 and Time$("seconds")<5 then WattHours=0 ' Reset Watthours at midnight.
    If LogOn=1 then gosub [SaveLog] ' Log data locally
    If RemoteOn=1 then gosub [SaveRemoteLog] ' Log data remotely
wait


[ParseData]
    PicAxeChecksum=0
    If InStr(SerialData$, "<V>") > 0 And InStr(SerialData$, "</V>") > InStr(SerialData$, "<V>") Then PicAxeV = val(Mid$(SerialData$, InStr(SerialData$, "<V>") + 3, InStr(SerialData$, "</V>") - InStr(SerialData$, "<V>") - 3))
    If InStr(SerialData$, "<I>") > 0 And InStr(SerialData$, "</I>") > InStr(SerialData$, "<I>") Then PicAxeA = val(Mid$(SerialData$, InStr(SerialData$, "<I>") + 3, InStr(SerialData$, "</I>") - InStr(SerialData$, "<I>") - 3))
    If InStr(SerialData$, "<R>") > 0 And InStr(SerialData$, "</R>") > InStr(SerialData$, "<R>") Then PicAxeR = val(Mid$(SerialData$, InStr(SerialData$, "<R>") + 3, InStr(SerialData$, "</R>") - InStr(SerialData$, "<R>") - 3))
    If InStr(SerialData$, "<S>") > 0 And InStr(SerialData$, "</S>") > InStr(SerialData$, "<S>") Then PicAxeS = val(Mid$(SerialData$, InStr(SerialData$, "<S>") + 3, InStr(SerialData$, "</S>") - InStr(SerialData$, "<S>") - 3))
    If InStr(SerialData$, "<C>") > 0 And InStr(SerialData$, "</C>") > InStr(SerialData$, "<C>") Then PicAxeChecksum = val(Mid$(SerialData$, InStr(SerialData$, "<C>") + 3, InStr(SerialData$, "</C>") - InStr(SerialData$, "<C>") - 3))
    BadData=0
    If PicAxeChecksum>0 then ' We have a later version PicLog with error checking code
        If PicAxeV+PicAxeA+PicAxeR+PicAxeS<>PicAxeChecksum then BadData=1
    end if
    ' Below we test if there is additional data after extracting this chunk. If so, keep it for the next ParseData pass, else delete the contents of the SerialData$
    d$=SerialData$
    if len(SerialData$)>BlockEndPos then
        SerialData$=mid$(SerialData$,BlockEndPos+1)
    else
        SerialData$=""
    end if
    ' Test to see if there was a block of bad data
    If BadData=1 then
        print #main.DataIndicator, "Corrupt Data! "
        Return
    else
        print #main.DataIndicator, "Received Data"
    end if
    ' Do the math
    Volts=PicAxeV*VoltMultiplier
    if abs(PicAxeA-AmpOffset)>AmpFilter then
        Amps=(PicAxeA-AmpOffset)*AmpMultiplier
    else
        Amps=0
    end if
    Watts=Volts*Amps
    RPM=PicAxeR*RPMMultiplier
    WindSpeed=PicAxeS*WSMultiplier
    ' Averages for local data
    If LogOn=1 then
        LogAvgVolts=LogAvgVolts+Volts
        LogAvgAmps=LogAvgAmps+Amps
        LogAvgWatts=LogAvgWatts+Watts
        LogAvgRPM=LogAvgRPM+RPM
        LogAvgWindSpeed=LogAvgWindSpeed+WindSpeed
        LogAvgCount=LogAvgCount+1
    end if
    ' Averages for remote data
    If RemoteOn=1 then
        RemoteAvgVolts=RemoteAvgVolts+Volts
        RemoteAvgAmps=RemoteAvgAmps+Amps
        RemoteAvgWatts=RemoteAvgWatts+Watts
        RemoteAvgRPM=RemoteAvgRPM+RPM
        RemoteAvgWindSpeed=RemoteAvgWindSpeed+WindSpeed
        if Watts>RemoteWattsPeak then RemoteWattsPeak=Watts
        if RPM>RemoteRPMPeak then RemoteRPMPeak=RPM
        if WindSpeed>RemoteWindSpeedPeak then RemoteWindSpeedPeak=WindSpeed
        RemoteAvgCount=RemoteAvgCount+1
    end if
    ' Display the data on screen
    DisplayBox$=trim$(using("###.##",Volts)) + "V"
    DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("###.##",Amps)) + "A"
    if Watts<1000 then DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("###.##",Watts)) + "W" else DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("####.#",Watts)) + "W"
    if WattHours<1000 then DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("###.#",WattHours)) + "Wh" else DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("####",WattHours)) + "Wh"
    if DisplayRPM=1 then DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("####.#",RPM)) + "RPM"
    if DisplayWS=1 then DisplayBox$=DisplayBox$ + chr$(13) + trim$(using("###.#",WindSpeed)) + WSUnits$
    print #main.DisplayBox, DisplayBox$
return


[SaveLog] ' Save a log entry
    LogTimer=LogTimer+1
    If LogTimer>=LogDelay then
        if LogAvgCount>0 then
            print #main.LogIndicator, "Saving Data"
            ' Work out averages
            LogAvgVolts=LogAvgVolts/LogAvgCount
            LogAvgAmps=LogAvgAmps/LogAvgCount
            LogAvgWatts=LogAvgWatts/LogAvgCount
            LogAvgRPM=LogAvgRPM/LogAvgCount
            LogAvgWindSpeed=LogAvgWindSpeed/LogAvgCount
            ' create file name based on todays date, and save data.
            LogFileName$="logfiles/" + replace$(date$("yyyy/mm/dd"),"/","_") + ".txt"
            Open LogFileName$ For append As #f
                Print #f, "<V>" + trim$(using("####.##",LogAvgVolts)) + "</V><I>" + trim$(using("####.##",LogAvgAmps)) + "</I><W>" + trim$(using("####.##",LogAvgWatts)) + "</W><Wh>" + trim$(using("####.##",WattHours)) + "</Wh><R>" + trim$(using("####.##",LogAvgRPM)) + "</R><S>" + trim$(using("####.##",LogAvgWindSpeed)) + "</S><T>" + time$() + "</T>"
            Close #f
            ' Reset averages to 0
            LogAvgCount=0
            LogTimer=0
            LogAvgVolts=0
            LogAvgAmps=0
            LogAvgWatts=0
            LogAvgRPM=0
            LogAvgWindSpeed=0
        else
            LogTimer=LogDelay
            print #main.LogIndicator, "Nothing to save! Check com data is coming in OK."
        end if
    else
        print #main.LogIndicator, str$(LogDelay-LogTimer) + " seconds till next log entry."
    end if
return


[SaveRemoteLog] ' Save data remotely
    RemoteTimer=RemoteTimer+1
    ' This code looks for a response file, to let us know data was received at the server
    if PageResponseDelay>0 then
        PageResponseDelay=PageResponseDelay+1
        if PageResponseDelay>=5 then ' Wait 5 seconds before looking for response from remote server.
            PageResponseDelay=0
            open "PageResponse.txt" for input as #f1
            html$ = trim$(input$(#f1, LOF(#f1)))
            close #f1
            print #main.RemoteLogResponse, html$
        end if
    end if
    ' This code sends the data to the server using some VB script
    If RemoteTimer>=600 then
        if  RemoteAvgCount>0 then
            print #main.RemoteLogIndicator, "Sending Data"
            ' Word out averages
            PageResponseDelay=1
            RemoteAvgVolts=RemoteAvgVolts/RemoteAvgCount
            RemoteAvgAmps=RemoteAvgAmps/RemoteAvgCount
            RemoteAvgWatts=RemoteAvgWatts/RemoteAvgCount
            RemoteAvgRPM=RemoteAvgRPM/RemoteAvgCount
            RemoteAvgWindSpeed=RemoteAvgWindSpeed/RemoteAvgCount
            RemoteTimer=0
            ' create url string
            Web$ = RemoteAd$
            Web$ = Web$ + "?T=" + replace$(date$("yyyy/mm/dd"),"/","_") + "_" + Time$()
            Web$ = Web$ + "&ID=" + RemoteID$
            Web$ = Web$ + "&PW=" + RemotePW$
            Web$ = Web$ + "&V=" + trim$(using("####.##",RemoteAvgVolts))
            Web$ = Web$ + "&I=" + trim$(using("####.##",RemoteAvgAmps))
            Web$ = Web$ + "&W=" + trim$(using("####.##",RemoteAvgWatts))
            Web$ = Web$ + "&S=" + trim$(using("####.##",RemoteAvgWindSpeed))
            Web$ = Web$ + "&R=" + trim$(using("####.##",RemoteAvgRPM))
            Web$ = Web$ + "&WH=" + trim$(using("####.##",WattHours))
            Web$ = Web$ + "&WP=" + trim$(using("####.##",RemoteWattsPeak))
            Web$ = Web$ + "&RP=" + trim$(using("####.##",RemoteRPMPeak))
            Web$ = Web$ + "&WSP=" + trim$(using("####.##",RemoteWindSpeedPeak))
            ' reset averages to 0
            RemoteAvgVolts=0
            RemoteAvgAmps=0
            RemoteAvgWatts=0
            RemoteAvgRPM=0
            RemoteAvgWindSpeed=0
            RemoteWattsPeak=0
            RemoteRPMPeak=0
            RemoteWindSpeedPeak=0
            RemoteTimer=0
            RemoteAvgCount=0
            ' run external VB script to send data
            run "cscript.exe OpenPage.vbs "; Web$; " PageResponse.txt", hide
        else
            RemoteTimer=600
            print #main.RemoteLogIndicator, "Nothing to send! Check com data is coming in OK."
        end if
    else
        print #main.RemoteLogIndicator, str$(600-RemoteTimer) + " seconds till next remote server update."
    end if
return


[GetConfig]
    Open "config.txt" For Input As #f
        ConfigData$ = input$(#f, LOF(#f))
    Close #f
    If InStr(ConfigData$, "<Port>") Then PortNumber$ = Mid$(ConfigData$, InStr(ConfigData$, "<Port>") + 6, InStr(ConfigData$, "</Port>") - InStr(ConfigData$, "<Port>") - 6)
    If InStr(ConfigData$, "<Baud>") Then BaudRate$ = Mid$(ConfigData$, InStr(ConfigData$, "<Baud>") + 6, InStr(ConfigData$, "</Baud>") - InStr(ConfigData$, "<Baud>") - 6)
    If InStr(ConfigData$, "<LogDelay>") Then LogDelay = val(Mid$(ConfigData$, InStr(ConfigData$, "<LogDelay>") + 10, InStr(ConfigData$, "</LogDelay>") - InStr(ConfigData$, "<LogDelay>") - 10))
    If InStr(ConfigData$, "<LogOn>") Then LogOn = val(Mid$(ConfigData$, InStr(ConfigData$, "<LogOn>") + 7, InStr(ConfigData$, "</LogOn>") - InStr(ConfigData$, "<LogOn>") - 7))
    If InStr(ConfigData$, "<DisplayRPM>") Then DisplayRPM = val(Mid$(ConfigData$, InStr(ConfigData$, "<DisplayRPM>") + 12, InStr(ConfigData$, "</DisplayRPM>") - InStr(ConfigData$, "<DisplayRPM>") - 12))
    If InStr(ConfigData$, "<DisplayWS>") Then DisplayWS = val(Mid$(ConfigData$, InStr(ConfigData$, "<DisplayWS>") + 11, InStr(ConfigData$, "</DisplayWS>") - InStr(ConfigData$, "<DisplayWS>") - 11))
    If InStr(ConfigData$, "<WSUnits>") Then WSUnits$ = Mid$(ConfigData$, InStr(ConfigData$, "<WSUnits>") + 9, InStr(ConfigData$, "</WSUnits>") - InStr(ConfigData$, "<WSUnits>") - 9)
    If InStr(ConfigData$, "<RemoteID>") Then RemoteID$ = Mid$(ConfigData$, InStr(ConfigData$, "<RemoteID>") + 10, InStr(ConfigData$, "</RemoteID>") - InStr(ConfigData$, "<RemoteID>") - 10)
    If InStr(ConfigData$, "<RemotePW>") Then RemotePW$ = Mid$(ConfigData$, InStr(ConfigData$, "<RemotePW>") + 10, InStr(ConfigData$, "</RemotePW>") - InStr(ConfigData$, "<RemotePW>") - 10)
    If InStr(ConfigData$, "<RemoteAD>") Then RemoteAd$ = Mid$(ConfigData$, InStr(ConfigData$, "<RemoteAD>") + 10, InStr(ConfigData$, "</RemoteAD>") - InStr(ConfigData$, "<RemoteAD>") - 10)
    If InStr(ConfigData$, "<RemoteOn>") Then RemoteOn = val(Mid$(ConfigData$, InStr(ConfigData$, "<RemoteOn>") + 10, InStr(ConfigData$, "</RemoteOn>") - InStr(ConfigData$, "<RemoteOn>") - 10))
    If InStr(ConfigData$, "<ResetMax>") Then ResetMax = val(Mid$(ConfigData$, InStr(ConfigData$, "<ResetMax>") + 10, InStr(ConfigData$, "</ResetMax>") - InStr(ConfigData$, "<ResetMax>") - 10))

    Open "calibration.txt" For Input As #f
        CalData$ = input$(#f, LOF(#f))
    Close #f
    VoltMultiplier = 1
    AmpOffset = 0
    AmpFilter = 0
    AmpMultiplier = 1
    RPMMultiplier = 1
    WSMultiplier = 1
    If InStr(CalData$, "<VoltMultiplier>") Then VoltMultiplier = Val(Mid$(CalData$, InStr(CalData$, "<VoltMultiplier>") + 16, InStr(CalData$, "</VoltMultiplier>") - InStr(CalData$, "<VoltMultiplier>") - 16))
    If InStr(CalData$, "<AmpOffset>") Then AmpOffset = Val(Mid$(CalData$, InStr(CalData$, "<AmpOffset>") + 11, InStr(CalData$, "</AmpOffset>") - InStr(CalData$, "<AmpOffset>") - 11))
    If InStr(CalData$, "<AmpFilter>") Then AmpFilter = Val(Mid$(CalData$, InStr(CalData$, "<AmpFilter>") + 11, InStr(CalData$, "</AmpFilter>") - InStr(CalData$, "<AmpFilter>") - 11))
    If InStr(CalData$, "<AmpMultiplier>") Then AmpMultiplier = Val(Mid$(CalData$, InStr(CalData$, "<AmpMultiplier>") + 15, InStr(CalData$, "</AmpMultiplier>") - InStr(CalData$, "<AmpMultiplier>") - 15))
    If InStr(CalData$, "<RPMMultiplier>") Then RPMMultiplier = Val(Mid$(CalData$, InStr(CalData$, "<RPMMultiplier>") + 15, InStr(CalData$, "</RPMMultiplier>") - InStr(CalData$, "<RPMMultiplier>") - 15))
    If InStr(CalData$, "<WSMultiplier>") Then WSMultiplier = Val(Mid$(CalData$, InStr(CalData$, "<WSMultiplier>") + 14, InStr(CalData$, "</WSMultiplier>") - InStr(CalData$, "<WSMultiplier>") - 14))

    PicAxeV=0
    PicAxeI=0
    PicAxeR=0
    PicAxeS=0
    if BaudRate$="" then BaudRate$="4800"

    ' Adjust DisplayBox font size depending on how many items to display
    Print #main.DisplayBox, ""
    Print #main.DisplayBox, "!font Microsoft_Sans_Serif 24"
    If DisplayRPM=1 or DisplayWS=1 then print #main.DisplayBox, "!font Microsoft_Sans_Serif 20"
    If DisplayRPM=1 and DisplayWS=1 then print #main.DisplayBox, "!font Microsoft_Sans_Serif 16"

Return


[CalScreen]     'Load up the Calibration Screen
    IF CalFlag=1 Then WAIT
    WindowWidth = 550
    WindowHeight = 580
    UpperLeftX=int((DisplayWidth-WindowWidth)/3)
    UpperLeftY=int((DisplayHeight-WindowHeight)/3)
    groupbox #CalScreen.gb1, "Step 1. Set Voltage", 26, 16, 490, 95
    statictext #CalScreen.txt1, "Measure your battery voltage, and then adjust this value until the correct battery voltage is displayed", 38, 41, 470, 20
    statictext #CalScreen.PicV, "0 X", 35, 66, 40, 20
    statictext #CalScreen.CalV, "0 Volts", 140, 66, 174, 20
    textbox #CalScreen.MultiV, 75, 61, 60, 25
    groupbox #CalScreen.gb2, "Step 2. Set Current", 26, 116, 490, 195
    statictext #CalScreen.txt5, "With no current flowing, press the Zero button to set the amp reading offset.", 38, 141, 470, 15
    statictext #CalScreen.txt6, "Apply a charging current and adjust this value until the correct amps is displayed.", 38, 181, 470, 20
    statictext #CalScreen.txt7, "If your current readings are erratic when there is no current flowing, you can set this value to filter out small fluchuations. Between 0 and 5 should do.", 38, 231, 470, 30
    statictext #CalScreen.PicA, "0 X", 35, 206, 40, 20
    statictext #CalScreen.CalA, "0 Amps", 140, 206, 144, 20
    statictext #CalScreen.OffsetA, str$(AmpOffset) + " offset", 140, 158, 60, 20
    button #CalScreen.Cal, "Zero", [ZeroAmpOffset], UL, 62, 158 , 50, 16
    textbox #CalScreen.MultiA, 75, 201, 60, 25
    textbox #CalScreen.FilterA, 75, 270, 60, 25
    groupbox #CalScreen.gb3, "Step 3. Set RPM", 26, 316, 490, 95
    statictext #CalScreen.txt10, "Use 60 / ( number of magnets in the alternator / 2 ).", 38, 341, 470, 20
    statictext #CalScreen.PicR, "0 X", 35, 366, 40, 20
    statictext #CalScreen.CalR, "0 RPM", 140, 366, 144, 20
    textbox #CalScreen.MultiR, 75, 361, 60, 25
    groupbox #CalScreen.gb4, "Step 4. Set Wind Speed", 26, 416, 490, 90
    statictext #CalScreen.txt20, "Per wind speed unit?", 38, 441, 470, 20
    statictext #CalScreen.PicS, "0 X", 35, 466, 40, 20
    statictext #CalScreen.CalS, "0 kmh", 140, 466, 144, 20
    textbox #CalScreen.MultiS, 75, 461, 60, 25
    button #CalScreen.Cal, "Cancel", [CancelCalibrate], UL, 360, 510 , 70, 25
    button #CalScreen.Cal, "Save", [SaveCalibrate], UL, 440, 510 , 70, 25

    open "PicLog Calibration" for window as #CalScreen
    print #CalScreen, "trapclose [CancelCalibrate]"
    print #CalScreen, "font ms_sans_serif 8"
    print #CalScreen.MultiV, VoltMultiplier
    print #CalScreen.MultiA, AmpMultiplier
    print #CalScreen.OffsetA, AmpOffset
    print #CalScreen.FilterA, AmpFilter
    print #CalScreen.MultiS, WSMultiplier
    print #CalScreen.MultiR, RPMMultiplier
    CalFlag=1
WAIT


[UpdateCalScreen]     'Update the Calibration Screen with live data
    TempNum1=0
    TempNum2=0
    print #CalScreen.PicV, str$(PicAxeV) + " X"
    print #CalScreen.PicA, str$(PicAxeA-AmpOffset) + " X"
    print #CalScreen.PicR, str$(PicAxeR) + " X"
    print #CalScreen.PicS, str$(PicAxeS) + " X"
    print #CalScreen.MultiV, "!contents? MultiV"
    print #CalScreen.CalV, "= " + str$(PicAxeV*MultiV) + " volts"
    print #CalScreen.MultiA, "!contents? MultiA"
    print #CalScreen.CalA, "= " + str$((PicAxeA-AmpOffset)*MultiA) + " amps"
    print #CalScreen.MultiR, "!contents? MultiR"
    print #CalScreen.CalR, "= " + str$(PicAxeR*MultiR) + " RPM"
    print #CalScreen.MultiS, "!contents? MultiS"
    print #CalScreen.CalS, "= " + str$(PicAxeS*MultiS) + " Wind Speed"
Return


[ZeroAmpOffset]
    AmpOffset=PicAxeA
    print #CalScreen.OffsetA, str$(AmpOffset) + " offset"
Wait


[CancelCalibrate]
    CalFlag=0
    CLOSE #CalScreen
WAIT


[SaveCalibrate]
    print #CalScreen.MultiV, "!contents? MultiV"
    print #CalScreen.MultiA, "!contents? MultiA"
    print #CalScreen.MultiR, "!contents? MultiR"
    print #CalScreen.MultiS, "!contents? MultiS"
    print #CalScreen.FilterA, "!contents? FilterA"
    Open "calibration.txt" For Output As #f
        Print #f, "<VoltMultiplier>" + str$(MultiV) + "</VoltMultiplier>"
        Print #f, "<AmpMultiplier>" + str$(MultiA) + "</AmpMultiplier>"
        Print #f, "<AmpOffset>" + str$(AmpOffset) + "</AmpOffset>"
        Print #f, "<AmpFilter>" + str$(FilterA) + "</AmpFilter>"
        Print #f, "<RPMMultiplier>" + str$(MultiR) + "</RPMMultiplier>"
        Print #f, "<WSMultiplier>" + str$(MultiS) + "</WSMultiplier>"
    Close #f
    CalFlag=0
    Gosub [GetConfig]
    CLOSE #CalScreen
WAIT


[SetupScreen]
    WindowWidth = 352
    WindowHeight = 490
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)
    groupbox #SetupScreen.gb1, "General Settings",  17,  12, 308, 180
    groupbox #SetupScreen.gb2, "Local Logging",  17, 200, 308, 90
    groupbox #SetupScreen.gb3, "Remote Logging",  17, 298, 308, 123
    combobox #SetupScreen.ComPort, ComArray$(), [DoNothing],  157,  26, 50, 100
    combobox #SetupScreen.BaudRate, BaudArray$(), [DoNothing],  157,  48, 50, 100
    statictext #SetupScreen.txt11, "Com port",  33,  32,  54,  20
    statictext #SetupScreen.txt11, "Baud Rate",  33,  52,  54,  20
    statictext #SetupScreen.txt20, "Log to internet server?",  31, 320, 120,  18
    statictext #SetupScreen.txt21, "Log ID",  31, 344,  35,  20
    statictext #SetupScreen.txt22, "Pin", 119, 344,  19,  20
    statictext #SetupScreen.txt23, "Server Address",  31, 368,  94,  18
    statictext #SetupScreen.txt27, "Display RPM",  33,  74,  79,  20
    statictext #SetupScreen.txt28, "Display wind speed",  33,  95, 110,  20
    statictext #SetupScreen.txt29, "Wind speed units",  33, 120, 103,  20
    statictext #SetupScreen.txt32, "Reset peaks at midnight",  33, 145, 115,  20
    statictext #SetupScreen.txt22, "Default logging interval",  31, 232, 110,  20
    statictext #SetupScreen.txt23, "Start logging automatically",  31, 256, 127,  20
    statictext #SetupScreen.txt23, "Seconds ( 10 to 600 )", 209, 230, 144,  20
    checkbox #SetupScreen.DisplayRPM, "", [DoNothing], [DoNothing], 157,  71,  82,  20
    checkbox #SetupScreen.DisplayWindSpeed, "", [DoNothing], [DoNothing], 157,  92,  31,  20
    checkbox #SetupScreen.ResetPeaks, "", [DoNothing], [DoNothing], 157, 142,  31,  20
    checkbox #SetupScreen.LogLocal, "", [DoNothing], [DoNothing], 157, 256,  31,  20
    checkbox #SetupScreen.LogInternet, "", [DoNothing], [DoNothing], 157, 316,  32,  20
    textbox #SetupScreen.WindSpeedUnits, 157,  116, 60,  25
    textbox #SetupScreen.LogInterval, 157, 224,  46,  26
    textbox #SetupScreen.RemoteID,  67, 337,  28,  26
    textbox #SetupScreen.RemotePin, 139, 337,  48,  26
    textbox #SetupScreen.RemoteServer,  31, 387, 278,  26
    button #SetupScreen.button48,"Cancel",[CancelSetup], UL, 203, 425,  64,  26
    button #SetupScreen.button49,"Save",[SaveSetup], UL, 275, 425,  50,  26

    open "PicLog Settings" for window as #SetupScreen
    print #SetupScreen, "trapclose [CancelSetup]"
    print #SetupScreen, "font ms_sans_serif 8"
    print #SetupScreen.WindSpeedUnits, WSUnits$
    print #SetupScreen.LogInterval, LogDelay
    print #SetupScreen.RemoteID, RemoteID$
    print #SetupScreen.RemotePin, RemotePW$
    print #SetupScreen.RemoteServer, RemoteAd$
    if LogOn=1 then print #SetupScreen.LogLocal, "set" else print #SetupScreen.LogLocal, "reset"
    if DisplayRPM=1 then print #SetupScreen.DisplayRPM, "set" else print #SetupScreen.DisplayRPM, "reset"
    if DisplayWS=1 then print #SetupScreen.DisplayWindSpeed, "set" else print #SetupScreen.DisplayWindSpeed, "reset"
    if RemoteOn=1 then print #SetupScreen.LogInternet, "set" else print #SetupScreen.LogInternet, "reset"
    if ResetMax=1 then print #SetupScreen.ResetPeaks, "set" else print #SetupScreen.ResetPeaks, "reset"
    print #SetupScreen.ComPort, "select " + PortNumber$
    if BaudRate$="" then BaudRate$="4800"
    print #SetupScreen.BaudRate, "select " + BaudRate$
Wait


[CancelSetup]
    CLOSE #SetupScreen
WAIT


[SaveSetup]
    Open "config.txt" For Output As #f
        print #SetupScreen.ComPort, "contents? PortNumber$"
        Print #f, "<Port>" + PortNumber$ + "</Port>"
        print #SetupScreen.BaudRate, "contents? BaudRate$"
        Print #f, "<Baud>" + BaudRate$ + "</Baud>"
        print #SetupScreen.LogLocal, "value? temp$"
        if temp$="set" then Print #f, "<LogOn>1</LogOn>" else Print #f,"<LogOn>0</LogOn>"
        print #SetupScreen.DisplayRPM, "value? temp$"
        if temp$="set" then Print #f, "<DisplayRPM>1</DisplayRPM>" else Print #f,"<DisplayRPM>0</DisplayRPM>"
        print #SetupScreen.DisplayWindSpeed, "value? temp$"
        if temp$="set" then Print #f, "<DisplayWS>1</DisplayWS>" else Print #f,"<DisplayWS>0</DisplayWS>"
        print #SetupScreen.LogInternet, "value? temp$"
        if temp$="set" then Print #f, "<RemoteOn>1</RemoteOn>" else Print #f,"<RemoteOn>0</RemoteOn>"
        print #SetupScreen.ResetPeaks, "value? temp$"
        if temp$="set" then Print #f, "<ResetMax>1</ResetMax>" else Print #f,"<ResetMax>0</ResetMax>"
        print #SetupScreen.WindSpeedUnits, "!contents? temp$"
        Print #f, "<WSUnits>" + temp$ + "</WSUnits>"
        print #SetupScreen.LogInterval, "!contents? temp$"
        Print #f, "<LogDelay>" + temp$ + "</LogDelay>"
        print #SetupScreen.RemoteID, "!contents? temp$"
        Print #f, "<RemoteID>" + temp$ + "</RemoteID>"
        print #SetupScreen.RemotePin, "!contents? temp$"
        Print #f, "<RemotePW>" + temp$ + "</RemotePW>"
        print #SetupScreen.RemoteServer, "!contents? temp$"
        Print #f, "<RemoteAD>" + temp$ + "</RemoteAD>"
    Close #f
    Gosub [GetConfig]
    if PortOpen=1 then
        Close #comm
        SerialData$=""
        Com=1024
        open "COM" + PortNumber$ + ":" + BaudRate$ + ",n,8,1,ds0,cs0,rs" for random as #comm
        PortOpen=1
    end if
    CLOSE #SetupScreen
    if PortOK=0 then goto [Start]
WAIT


[ComDataScreen]
    IF ComDataFlag=1 Then WAIT
    WindowWidth = 450
    WindowHeight = 80
    UpperLeftX=int((DisplayWidth-WindowWidth)/3)
    UpperLeftY=int((DisplayHeight-WindowHeight)/3)
    statictext #ComDataScreen.ComData, "Com Data Display", 18, 15, 800, 20
    open "PicLog Com Port Data " for window as #ComDataScreen
    print #ComDataScreen, "trapclose [CloseComDataScreen]"
    print #ComDataScreen, "font ms_sans_serif 10"
    ComDataFlag=1
WAIT


[CloseComDataScreen]
    ComDataFlag=0
    CLOSE #ComDataScreen
WAIT


[ResetWatthours]
    WindowWidth = 200
    WindowHeight = 80
    UpperLeftX=int((DisplayWidth-WindowWidth)/3)
    UpperLeftY=int((DisplayHeight-WindowHeight)/3)
    textbox #ResetWattHoursScreen.WattHoursNewValue 10, 10, 60, 25
    button #ResetWattHoursScreen.ApplyButton, "Apply", [ResetWattHoursApply], UL, 80, 12 , 50, 22
    button #ResetWattHoursScreen.CancelButton, "Cancel", [ResetWattHoursCancel], UL, 135, 12 , 50, 22

    open "Reset Wh" for window as #ResetWattHoursScreen
    print #ResetWattHoursScreen, "trapclose [ResetWattHoursCancel]"
    print #ResetWattHoursScreen.WattHoursNewValue, "0"
    ResetWatthours=1
WAIT


[ResetWattHoursApply]
    print #ResetWattHoursScreen.WattHoursNewValue, "!contents? WattHoursNewValue$"
    WattHours=val(WattHoursNewValue$)
    ResetWatthours=0
    CLOSE #ResetWattHoursScreen
WAIT


[ResetWattHoursCancel]
    ResetWatthours=0
    CLOSE #ResetWattHoursScreen
WAIT


function replace$(temp1$,temp2$,temp3$) 'JustBASIC doesn't have a REPLACE function, so we need to make our own
    if instr(temp1$,temp2$)=0 then
        replace$=temp1$
    else
        replace$=""
        do until instr(temp1$,temp2$)=0
            characterposition=instr(temp1$,temp2$)
            replace$=replace$ + left$(temp1$,characterposition-1) + temp3$
            temp1$=mid$(temp1$,characterposition+1)
        loop
        replace$=replace$+temp1$
    end if
end function


[DoNothing]
wait


[OpenPicGraph]
run "PicGraph.exe"
wait


[quit]
    Close #comm
    Close #main
END
